import PlayScene from "../../src/playScene/PlayScene";
import StartScene from "../../src/startScene/StartScene";
import getResPath from "../new_tc/getResPath";
import { DataManager } from "../tw/manager/DataManager";
import { NetManager } from "../tw/manager/NetManager";
import AssetAdapter from "./adapter/AssetAdapter";
import ThemeAdapter from "./adapter/ThemeAdapter";
import Alert from "./components/Alert";
import HTMLRulePanel from "./components/HTMLRulePanel";
import Loading from "./components/Loading";
import OptionsPanel from "./components/OptionsPanel";
import PrizePanel from "./components/PrizePanel";
import RankPanel from "./components/RankPanel";
import RulePanel from "./components/RulePanel";
import PanelCtrl from "./ctrls/panelCtrl";
import SceneCtrl from "./ctrls/sceneCtrl";
import showAlertPanel from "./ctrls/showAlertPanel";
import { ModuleTypes } from "./types/sceneTypes";
import layers from "./views/layers";
import RelivePanel from "../../src/panels/RelivePanel";
import NoPrizePanel from "./components/NoPrizePanel";
import { Buried } from "../tw/util/Buried";

export default class MainBase extends eui.UILayer {
    constructor() {
        super();
        Loading.instace.loadImage();
        DataManager.ins.customCfgData = window['CFG'];
        this.getData();
    }

    protected registerModules() {
        const panels = [
            [ModuleTypes.ALERT_PANEL, { cls: Alert }],
            [ModuleTypes.RELIVE_PANEL, { cls: RelivePanel }],
            [ModuleTypes.RULE_PANEL, { cls: RulePanel }],
            [ModuleTypes.HTML_RULE_PANEL, { cls: HTMLRulePanel }],
            [ModuleTypes.OPTIONS_PANEL, { cls: OptionsPanel }],
            [ModuleTypes.PRIZE_PANEL, { cls: PrizePanel }],
            [ModuleTypes.NO_PRIZE_PANEL, { cls: NoPrizePanel }],
            [ModuleTypes.RANK_PANEL, { cls: RankPanel }],
        ];

        const scenes = [
            [ModuleTypes.START_SCENE, { cls: StartScene }],
            [ModuleTypes.PLAY_SCENE, { cls: PlayScene }]
        ];

        panels.forEach(item => PanelCtrl.instance.registerPanel(item[0], item[1]));
        scenes.forEach(item => SceneCtrl.instance.registerScene(item[0], item[1]));

        // NetManager.ins.onNotSuccess = (msg) => {
        //    s
        // }
    }

    protected getData() {

    }

    protected createChildren(): void {
        super.createChildren();
        egret.lifecycle.addLifecycleListener((context) => {
            // custom lifecycle plugin
        })

        egret.lifecycle.onPause = () => {
            // egret.ticker.pause();
        }

        egret.lifecycle.onResume = () => {
            // egret.ticker.resume();
        }

        //inject the custom material parser
        //注入自定义的素材解析器
        const assetAdapter = new AssetAdapter();
        egret.registerImplementation("eui.IAssetAdapter", assetAdapter);
        egret.registerImplementation("eui.IThemeAdapter", new ThemeAdapter());

        egret.ImageLoader.crossOrigin = "anonymous";

        layers.init(this);
        Loading.init(layers.topLayer);
        Loading.instace.show();

        PanelCtrl.instance.init(layers.popupLayer);
        SceneCtrl.instance.init(layers.sceneLayer);

        this.stage.scaleMode = egret.StageScaleMode.FIXED_WIDTH;

        this.registerModules();

        Loading.instace.show();

        RES.setMaxLoadingThread(10);
        this.runGame().catch(e => {
            console.log(e);
        })
    }

    private async runGame() {
        await this.loadResource()

        if (!window['development'])
            RES.getResAsync(`common_json`);
        else {
            // RES.getResAsync('toast_png');
            RES.getResAsync('alertbg_png');
            RES.getResAsync('ball_png');
            RES.getResAsync('+1_png');
            RES.getResAsync('circle1_png');
            RES.getResAsync('sq1_png');
            RES.getResAsync('sq2_png');
            RES.getResAsync('sq3_png');
            RES.getResAsync('sq4_png');
            RES.getResAsync('tri1_png');
            RES.getResAsync('tri2_png');
        }

        this.createGameScene();
    }

    private async loadResource() {
        try {
            await RES.loadConfig("default.res.json", getResPath() + "resource/");
            await this.loadTheme();
        }
        catch (e) {
            console.error(e);
        }
    }

    private loadTheme() {
        return new Promise((resolve, reject) => {
            // load skin theme configuration file, you can manually modify the file. And replace the default skin.
            //加载皮肤主题配置文件,可以手动修改这个文件。替换默认皮肤。
            const theme = new eui.Theme("resource/default.thm.json", this.stage);
            theme.addEventListener(eui.UIEvent.COMPLETE, () => {
                resolve();
            }, this);

        })
    }

    protected createGameScene() {
        NetManager.ins.ajaxElement(async () => {
            Buried.init();

            SceneCtrl.instance.change(ModuleTypes.START_SCENE);

        })

    }
}